<template>
  <div class="main-contain">
    <div class="position">
      <bread-crumb
        v-if="this.$route.query.type == 1"
        :crumbs="crumbs"
      ></bread-crumb>
      <bread-crumb
        v-if="this.$route.query.type == 2"
        :crumbs="crumbs2"
      ></bread-crumb>

      <div style="float:right;">
        <el-button size="small" @click="back()" class="filter-item"
          >取 消</el-button
        >
        <el-button
          size="small"
          type="primary"
          @click="submit()"
          class="filter-item"
          >保 存</el-button
        >
      </div>
    </div>

    <div class="app-container">

      <stock-in-dialog
        ref="dialog"
        :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle"
      ></stock-in-dialog>
      <div class="filter-container">
        <div class="cell clearfix">
         <label class="title"><span class="name"><span style="color:red">*</span>仓库</span> :</label>
         <el-select size="small" v-model="storehouse_id" filterable placeholder="请选择仓库" style="width:200px">
              <el-option
                v-for="(option, index) in list"
                :key="index"
                :label="option.storehouse_name"
                :value="option.id">
              </el-option>
         </el-select>
          <label class="title"><span class="name">退库时间</span> : </label>
          <el-date-picker
            size="small"
            v-model="return_time"
            prefix-icon="el-icon-date"
            :editable="false"
            style="width: 196px;"
            type="date"
            placeholder="选择日期时间"
            align="right"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
          ></el-date-picker>
        </div>
      </div>

      <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table
          :data="recordInfo.recordData"
          :class="signAndWeighBoxPatients"
          style="width: 100%"
          border
          max-height="450"
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)' }"
        >
       
         <el-table-column align="center" width="320" fixed="left">
       
             <template slot="header" slot-scope="scope">
              <span>耗材名称</span>
            </template>
            <template slot-scope="scope">
                <el-autocomplete
                    class="checkSearch"
                    popper-class="my-autocomplete"
                    v-model="scope.row.good_name"
                    :fetch-suggestions="querySearchAsync"
                    :trigger-on-focus="true"
                    placeholder="请输入耗材名称"
                    @select="handleSelect"
                    @input="changeGoodName(scope.$index)"
                    style="width:280px;"
                  >
                    <i class="el-icon-search el-input__icon" slot="suffix"></i>
                  <template slot-scope="{ item }">
                    <div class="name">{{ item.good_name +"  " +item.specification_name + "  "+item.manufacturer }}</div>
                  </template>
                 </el-autocomplete>
            </template>
          </el-table-column>
          <el-table-column align="center" width="140">
            <template slot="header" slot-scope="scope">
              <span>规格&单位<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">

              <el-form-item style="padding-top: 20px">
                <el-input placeholder="请输入规格名称" v-model="scope.row.name"></el-input>
              </el-form-item>

            </template>
          </el-table-column>
        
          <el-table-column width="120" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                :rules="tableRules.return_count"
                style="padding-top: 17px"
              >
                <el-input
                  oninput="value=value.replace(/\D|^0/g,'')"
                  placeholder="请输入退库数量"
                  type="number"
                  v-model="scope.row.return_count"
                ></el-input>      
              </el-form-item>
            
            </template>
          </el-table-column>
          <el-table-column width="120" align="center">
            <template slot="header" slot-scope="scope">
              <span>单价<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.price'"
                :rules="tableRules.price"
                style="padding-top: 17px"
              >
                <el-input
                 
                  placeholder="请输入单价"
                  type="number"
                  v-model="scope.row.price"
                ></el-input>      
              </el-form-item>
              <!-- {{scope.row.packing_unit}} -->
            </template>
          </el-table-column>
          <el-table-column label="总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.return_count) }}
            </template>
          </el-table-column>
          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>批次<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                style="padding-top: 17px"
              >
               <el-select v-model="scope.row.number" filterable placeholder="请选择">
                  <el-option
                    v-for="(item,index) in scope.row.xt_warehouse_info"
                    :key="index"
                    :label="item.number"
                    :value="item.id">
                  </el-option>
              </el-select>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>品名/注册证号(备案凭证号)<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                style="padding-top: 17px"
              >
              <el-input v-model="scope.row.register_account"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
           <el-table-column label="生产厂家" width="160" align="center">
            <template slot-scope="scope">
               <el-select v-model="scope.row.manufacturer" filterable placeholder="请选择厂商">
                <el-option
                  v-for="(option, index) in manufacturerList"
                  :key="index"
                  :label="option.manufacturer_name"
                  :value="option.manufacturer_name">
                </el-option>
               </el-select>
            </template>
          </el-table-column>
 

          <el-table-column label="生产日期" width="180" align="center">
            <template slot-scope="scope">
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.product_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="有效日期" width="180" align="center">
            <template slot-scope="scope">
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.expiry_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>


        <el-table-column label="经销商" width="160" align="center">
            <template slot-scope="scope">
                <el-select v-model="scope.row.dealer" filterable placeholder="请选择厂商">
                <el-option
                  v-for="(option, index) in dealerList"
                  :key="index"
                  :label="option.dealer_name"
                  :value="option.dealer_name">
                </el-option>
                </el-select>
            </template>
          </el-table-column>
          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库原因<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.remark'"
                style="padding-top: 17px"
              >
              <el-input v-model="scope.row.remark"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" width="200" fixed="right">
            <template slot-scope="scope">
              <el-tooltip
                class="item"
                effect="dark"
                content="新增"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEdit(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
              <el-tooltip
                class="item"
                effect="dark"
                content="删除"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>
        </el-table>
      </el-form>
    </div>
  </div>
</template>

<script>
import { uParseTime } from "@/utils/tools";
import { postCancelStock,GetAllConfig,GetAllGoodInfoByID,postSearchGoodList,getStockBatchNumber } from "@/api/stock";
import BreadCrumb from "../components/bread-crumb";
import StockInDialog from './Dialog/stockInDialog'

export default {
  components: { StockInDialog, BreadCrumb },
  name: "salesReturnOrderAdd",

  data() {
    return {
      crumbs: [
        { path: false, name: "库存管理" },
        { path: false, name: "耗材退库单" },
        { path: false, name: "新增退库单" }
      ],
      crumbs2: [
        { path: false, name: "库存管理" },
        { path: false, name: "其他退库单" },
        { path: false, name: "新增退库单" }
      ],

      type: this.$route.query.type,
      signAndWeighBoxPatients: "sign-and-weigh-box-patients",
      return_time: "",
      currentIndex: 0,
      recordInfo: {
        recordData: []
      },
      tableRules: {
        return_count: [
          { required: true, message: "数量不能为空", trigge: "blur" }
        
        ],
        // price: [
        //   { required: true, message: "单价不能为空", trigge: "blur" }
        // ]
      },
      ruleForm: {
        manufacturer: [
          { required: true, message: "请选择厂商", trigger: "change" }
        ]
      },
      // prop
      isVisibility: false,
      propForm: {
        goods: [],
        goodType: [],
        goodInfo: [],
        goodUnit: [],
        manufacturer: 0,
        dealer: 0
      },
      form: {
        manufacturer: 0,
        dealer: 0
      },
      warehouseOutInfoList: [],
      manufacturer: [],
      dealer: [],
      goodType: [],
      goodInfo:[],
      numberList:[],
      dealerList:[],
      manufacturerList:[],
      list:[],
      storehouse_id:"",
    };
  },
  methods: {
    comfirm: function(val) {
      this.propForm.goodType = []
      this.propForm.goods = []

      this.$refs.dialog.hide()
      if (val.selectedGoodInfo.length > 0) {
        for (let i = val.selectedGoodInfo.length - 1; i >= 0; i--) {
          if (i == 0) {
            this.recordInfo.recordData[this.currentIndex].good_type_id = val.selectedGoodInfo[i].good_type_id
            this.recordInfo.recordData[this.currentIndex].good_id = val.selectedGoodInfo[i].id

          } else {
            const tempForm = {}
            tempForm['good_type_id'] =val.selectedGoodInfo[i].good_type_id
            tempForm['good_id'] = val.selectedGoodInfo[i].id
            tempForm["return_count"] = "";

            this.recordInfo.recordData.splice(this.currentIndex + 1, 0, tempForm)
          }
        }
      }
      this.currentIndex = -1

    },

    cancle: function() {
      this.$refs.dialog.hide();
      this.propForm.goodType = [];
    },
    GetConfigInfo: function() {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })

      GetAllConfig().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg)
          return false
        } else {
          this.manufacturer = response.data.data.manufacturer
          this.dealer = response.data.data.dealer
          this.goodType = response.data.data.goodType
          this.goodInfo = response.data.data.goodInfo
          this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: '全部' })
          this.dealer.splice(0, 0, { id: 0, dealer_name: '全部' })
          this.manufacturer.splice(0, 0, { id: -1, manufacturer_name: '其他' })
          this.dealer.splice(0, 0, { id: -1, dealer_name: '其他' })
          this.form.manufacturer = 0
          this.form.dealer = 0
          this.list = response.data.data.list
          this.storehouse_id = response.data.data.configlist.storehouse_out_info
        }
        loading.close()
      })

    },

    typeName: function(good_type_id) {
      let name = "";
      for (let i = 0; i < this.goodType.length; i++) {
        if (this.goodType[i].id == good_type_id) {
          name = this.goodType[i].type_name;
        }
      }
      return name;
    },
    specificationName: function(good_info_id) {
      let name = ''
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == good_info_id) {
          name = this.goodInfo[i].specification_name
        }
      }
      return name
    },
    handleEdit: function(index, row) {
      const tempObj = {};
      tempObj["good_type_id"] = 0;
      tempObj["good_id"] = 0;
      tempObj["return_count"] = "";
      tempObj["number"] = ""
      tempObj["dealer"] = ""
      tempObj["manufacturer"]= ""
      tempObj["register_account"] = ""
      tempObj["remark"] = ""
      tempObj["price"] = ""
      tempObj["total"] = ""
      tempObj["warehouse_info_id"] =  0
      tempObj["xt_warehouse_info"] = []
      this.recordInfo.recordData.push(tempObj);
    },
    handleDelete: function(index, row) {
      if (this.recordInfo.recordData.length <= 1) {
        this.$message.error("只有一条记录的时候无法删除");
        return;
      } else {
        this.recordInfo.recordData.splice(index, 1);
      }
    },
    calculate: function(val) {
      if (val == 0) {
        return "";
      }

      return Math.round(parseFloat(val) * 100) / 100;
    },
    getTime(val, temp) {
      if (val != 0) {
        return uParseTime(val, temp);
      } else {
        return "";
      }
    },
    showDialog(index, row) {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      this.currentIndex = index
      this.isVisibility = true
      const params = {
        manufacturer_id: this.form.manufacturer,
        dealer_id: this.form.dealer
      }
      this.propForm.goods = []

      GetAllGoodInfoByID(params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
            loading.close()

          } else {
            loading.close()

            if (response.data.data.goodInfo.length <= 0) {
              this.$message.error('该厂商或经销商没有物品信息')
              return
            }
            this.$refs.dialog.show()
            for (let i = 0; i < response.data.data.goodInfo.length; i++) {
              this.propForm.goodType.push(response.data.data.goodInfo[i].type)
            }
            const obj = {}
            this.propForm.goodType = this.propForm.goodType.reduce((cur, next) => {
              obj[next.id] ? '' : obj[next.id] = true && cur.push(next)
              return cur
            }, []) // 设置cur默认类型为数组，并且初始值为空的数组
          }

          for (let i = 0; i < this.propForm.goodType.length; i++) {
            let goodInfo = []
            let goodObj = {}

            for (let a = 0; a < response.data.data.goodInfo.length; a++) {
              var respObj = response.data.data.goodInfo[a]
              respObj['isSelected'] = false
              if (respObj.type.id == this.propForm.goodType[i].id) {
                goodInfo.push(respObj)
              }
            }
            const obj = {}
            goodInfo = goodInfo.reduce((cur, next) => {
              obj[next.id] ? '' : obj[next.id] = true && cur.push(next)
              return cur
            }, []) // 设置cur默认类型为数组，并且初始值为空的数组

            this.$set(goodObj, this.propForm.goodType[i].id, goodInfo)
            this.propForm.goods.push(goodObj)
          }
        }
      )
    },

    back() {
      this.$router.go(-1);
    },
    submit() {
      this.$refs["tableForm"].validate(valid => {
        if (valid) {
          const array = this.recordInfo.recordData;
          let total = 0;
          for (let i = 0; i < array.length; i++) {
            array[i].price = (array[i].price).toString()
            total = total + array[i].price * array[i].return_count;
            if(array[i].number == undefined){
               array[i].number = ""
            }
          }

          if (this.recordInfo.recordData.length <= 0) {
            this.$message.success("请添加退库商品");
            return;
          }
   
          for(let i=0;i<this.recordInfo.recordData.length;i++){
            if(this.recordInfo.recordData[i].good_id == 0){
               this.$message.error("耗材规格不能为空")
               return
            }
            for(let j=0;j<this.recordInfo.recordData[i].xt_warehouse_info.length;j++){
               if(this.recordInfo.recordData[i].number == this.recordInfo.recordData[i].xt_warehouse_info[j].id){
                  this.recordInfo.recordData[i].number = this.recordInfo.recordData[i].xt_warehouse_info[j].number
                  this.recordInfo.recordData[i].warehouse_info_id = this.recordInfo.recordData[i].xt_warehouse_info[j].id
               }
            }     
          }
          const loading = this.$loading({
            lock: true,
            text: 'Loading',
            spinner: 'el-icon-loading',
            background: 'rgba(0, 0, 0, 0.7)'
          })
          const params = {
            cancelStock: this.recordInfo.recordData
          };
         
          postCancelStock(
            params,
            this.return_time,
            this.form.manufacturer,
            this.form.dealer,
            this.type,
            this.storehouse_id,
          ).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              loading.close()
              return false;
            } else {
             var msg =  response.data.data.msg
             var good_name = response.data.data.good_name
             var specification_name = response.data.data.specification_name
             var storehose_name = response.data.data.storehouse_name
            var str = storehose_name + " " + good_name +"*" + specification_name +"该批次退库数量大于出库数量"
             if (msg == 1){
                this.$message.error("无出库记录")
                return
             }
             if(msg == 2){
               this.$message.error(str)
             }
              if(msg == 4){
               this.$message.error(str)
             }
             if(msg == 5){
              this.$message.error(str)
             }
             if(msg == 3){
               this.$notify({
                title: "成功",
                message: "退库成功",
                type: "success",
                duration: 2000
              });
              this.recordInfo.recordData = [];
              this.$router.back(-1);
             }  
             loading.close()      
            }
          });
        } else {
          return false;
        }
      });
    },
    changeManufacturer(val) {
      this.propForm.manufacturer = val;
    },
    changeDealer(val) {
      this.propForm.dealer = val;
    },
    querySearchAsync(keyword, cb) {
      let key = '';
      if (keyword != undefined) {
        key = keyword
      }
    postSearchGoodList(key,this.storehouse_id).then(response => {
        if (response.data.state == 1) {
            var list = response.data.data.list
           
            this.goodList = list
            var manufacturerList = response.data.data.manufacturerList
            this.manufacturerList = manufacturerList
            var dealer =  response.data.data.dealerList
            this.dealerList = dealer
            for(let i=0;i<this.goodList.length;i++){
              for(let j=0;j<this.manufacturerList.length;j++){
                if(this.goodList[i].manufacturer == this.manufacturerList[j].id){
                    this.goodList[i].manufacturer = this.manufacturerList[j].manufacturer_name
                }
              }
            }

            for(let i=0;i<this.goodList.length;i++){
              for(let j=0;j<this.dealerList.length;j++){
                if(this.goodList[i].dealer == this.dealerList[j].id){
                  this.goodList[i].dealer = this.dealerList[j].dealer_name
                }
              }
            }
          
            cb(this.goodList)
        } else {
          cb([])
        }
      })
    },
    changeGoodName(val){
      this.currentIndex = val
    },
    handleSelect(val){
     
      for(let i=0;i<this.recordInfo.recordData.length;i++){
        if(this.currentIndex == i){
          this.recordInfo.recordData[i].good_name = val.good_name
          this.recordInfo.recordData[i].good_type_id = val.good_type_id
          this.recordInfo.recordData[i].name = val.specification_name +"/"+val.packing_unit
          this.recordInfo.recordData[i].number =  ""
          this.recordInfo.recordData[i].manufacturer = val.manufacturer
          this.recordInfo.recordData[i].remark = val.remark
          this.recordInfo.recordData[i].xt_warehouse_info = val.xt_warehouse_info
          if(val.buy_price == 0){
            this.recordInfo.recordData[i].price = ""
          }else{
            this.recordInfo.recordData[i].price = val.buy_price
          }
          
          this.recordInfo.recordData[i].specification_name = val.specification_name
          this.recordInfo.recordData[i].good_id = val.id
          this.recordInfo.recordData[i].packing_unit = val.packing_unit
          if(val.dealer == 0){
            this.recordInfo.recordData[i].dealer = ""
          }else{
            this.recordInfo.recordData[i].dealer = val.dealer
          }
          
        }
      }
    },
    getStockBatchNumber(id){
       var params = {
         id:id
       }
      getStockBatchNumber(params).then(response=>{
        if(response.data.state == 1){
          var list = response.data.data.list
          this.numberList = []
          this.numberList = list
        }
     })
    },
  },
  created() {
    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.return_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);

    const tempObj = {};
    tempObj["good_type_id"] = 0;
    tempObj["good_id"] = 0;
    tempObj["return_count"] = "";
    tempObj["number"] = ""
    tempObj["dealer"] = ""
    tempObj["manufacturer"]= ""
    tempObj["register_account"] = ""
    tempObj["remark"] = ""
    tempObj["price"] = ""
    tempObj["total"] = ""
    tempObj["warehouse_info_id"] = 0
    tempObj["xt_warehouse_info"] = []
    this.recordInfo.recordData.push(tempObj);
    this.GetConfigInfo();
    this.propForm.goodUnit = this.$store.getters.good_unit;
  }
};
</script>

<style rel="stylesheet/css" lang="scss" scoped>
.information {
  border: 1px #dcdfe6 solid;
  padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }
}

.edit_separater {
  border-top: 1px solid rgb(233, 233, 233);
  margin-top: 15px;
  margin-bottom: 15px;
}
</style>

<style>
.sign-and-weigh-box .sign-and-weigh-box-patients .cell {
  font-size: 12px;
}

.sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
  background: #6fb5fa;
}
</style>
